//	ASSetPropFlags (Questionbox.prototype, ['function'], 1);

Questionbox = function () {}

Questionbox.prototype = new MovieClip ();

// ---------------- INITIALIZATION --------------------

Questionbox.prototype.initialize = function (bgcolors, olcolors, textcolors, textformat, textpadding, xmlnode) {
	this.active = true;
	this.alive = true;
	this.clicked = false;

	this.bgcolors = bgcolors;
	this.olcolors = olcolors;
	this.bgcol = new Color (this.i_bg);
	this.olcol = new Color (this.i_ol);
	this.bgcol.setRGB (this.bgcolors[0]);
	this.olcol.setRGB (this.olcolors[0]);
	
	this.ycursor = 0;

	this.textcolors = textcolors;
	this.textformat = textformat;
	this.textformat.color = this.textcolors[0];
	this.textpadding = textpadding;
	this.answertext = answertext;
	this.answeriscorrect = answeriscorrect;
	
	this.createTextField ('i_text', 10, this.textpadding, Math.floor (this.textpadding * .8), this._width - this.textpadding * 2, this._height * 4);
	this.i_text.multiline = true;
	this.i_text.wordWrap = true;
	this.i_text.embedFonts = true;
	this.i_text.selectable = false;
	this.i_text.html = true;
	this.i_text.setNewTextFormat (this.textformat);
	this.i_text.htmlText = this.answertext;
	this.i_text.setTextFormat (this.textformat);
	this.i_text._height = this.i_text.textHeight + 6;
	
	var l = Math.floor (this.i_text.textHeight / this.textformat.size);
	l = (l == 0) ? 1 : l;
	
	ASSetPropFlags (Questionbox.prototype, ['initialize'], 1);
}

// --------------------- METHODS --------------------

Questionbox.prototype.onRollOver = function () {
	if (this.active && this.alive) {
		this.bgcol.setRGB (this.bgcolors[1]);
		this.olcol.setRGB (this.olcolors[1]);
	}
	ASSetPropFlags (Questionbox.prototype, ['onRollOver'], 1);
}

Questionbox.prototype.onRollOut = function () {
	if (this.active && this.alive) {
		this.bgcol.setRGB (this.bgcolors[0]);
		this.olcol.setRGB (this.olcolors[0]);
	}
	ASSetPropFlags (Questionbox.prototype, ['onRollOut'], 1);
}

Questionbox.prototype.onRelease = function () {
	if (this.active && this.alive) {
		this.clicked = true;
	}
	ASSetPropFlags (Questionbox.prototype, ['onRelease'], 1);
}

Questionbox.prototype.kill = function () {
	this.alive = false;
	this.useHandCursor = false;
	if (this.answeriscorrect & this.clicked) {
		this.bgcol.setRGB (this.bgcolors[3]);
		this.olcol.setRGB (this.olcolors[3]);
		this.newTf = new TextFormat ();
		this.newTF.color = this.textcolors[3];
		this.i_text.setTextFormat (this.newTf);
		delete (this.newTf);
	} else if (this.answeriscorrect) {
		this.bgcol.setRGB (this.bgcolors[5]);
		this.olcol.setRGB (this.olcolors[5]);
	} else if (this.clicked) {
		this.bgcol.setRGB (this.bgcolors[4]);
		this.olcol.setRGB (this.olcolors[4]);
	} else {
		this.bgcol.setRGB (this.bgcolors[2]);
		this.olcol.setRGB (this.olcolors[2]);
	}
	ASSetPropFlags (Questionbox.prototype, ['kill'], 1);
}

Questionbox.prototype.activate = function () {
	ASSetPropFlags (Questionbox.prototype, ['activate'], 1);
}

Questionbox.prototype.deactivate = function () {
	ASSetPropFlags (Questionbox.prototype, ['deactivate'], 1);
}

Object.registerClass ('m_ansbox', Questionbox);
